<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->

<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:param name="pageName" value="#{messages['net.ihe.gazelle.EVSClient-ui.ValidationServiceDefinition']}"/>
    <ui:param name="pageNameUrl" value="administration/validationServices.seam"/>
    <ui:param name="pageNameTitle" value="#{messages['net.ihe.gazelle.EVSClient-ui.ValidationServiceDefinition']}"/>
    <ui:define name="body">
        <h:form id="globalForm">
            <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">

                <ui:define name="panel_title">
                    <h:outputText value="#{messages['net.ihe.gazelle.AddValidationService']}"
                                  rendered="#{validationServiceBeanGui.isCreation()}"/>
                    <h:outputText value="#{messages['net.ihe.gazelle.evs.EditValidationService']}"
                                  rendered="#{!validationServiceBeanGui.isCreation()}"/>
                </ui:define>

                <s:div id="validationServiceTypeDiv">
                    <div class="form-horizontal">
                        <s:decorate id="typeDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.evs.ValidationServiceType']}</ui:define>
                            <h:selectOneMenu id="serviceTypeSelectMenu"
                                             value="#{validationServiceBeanGui.validationServiceDto.validationServiceType}"
                                             required="true"
                                             styleClass="form-control gzl-form-control gzl-select-text"
                                             hideNoSelectionOption="true"
                                             disabled="#{!validationServiceBeanGui.isCreation()}">
                                <f:selectItems value="#{validationServiceBeanGui.getValidationServiceTypesAsSelectItems()}"/>
                                <a4j:ajax event="change" render="specificDiv,validatorTypeDecoration" execute="@this"/>
                            </h:selectOneMenu>
                        </s:decorate>
                    </div>
                </s:div>

                <s:div id="sharedDiv">
                    <div class="form-horizontal">

                        <s:decorate id="validatorTypeDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                            <ui:param name="id" value="selectNameId"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.evs.ValidatorType']}</ui:define>
                            <h:selectOneMenu id="selectNameId" value="#{validationServiceBeanGui.validationServiceDto.validationType}"
                                             required="true" styleClass="form-control gzl-form-control gzl-select-text">
                                <f:selectItems value="#{validationServiceBeanGui.getValidatorFriendlyNamesAsSelectItems()}"/>
                                <a4j:ajax event="change" render="validatorTypeDecoration" execute="@this"/>
                            </h:selectOneMenu>
                        </s:decorate>

                        <s:decorate id="nameDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                            <ui:define name="label">#{messages['gazelle.evs.client.Name']}</ui:define>
                            <ui:param name="id" value="name"/>
                            <h:inputText id="name" size="60" maxlength="255"
                                         required="true" styleClass="form-control"
                                         value="#{validationServiceBeanGui.validationServiceDto.name}">
                                <a4j:ajax event="blur" render="nameDecoration" execute="@this"/>
                            </h:inputText>
                        </s:decorate>

                        <s:decorate id="stylesheetReportLocationDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.evs.StylesheetReportLocation']}</ui:define>
                            <rich:autocomplete id="xslLocation" size="60" maxlength="255"
                                               required="true"
                                               value="#{validationServiceBeanGui.validationServiceDto.stylesheetReportLocation}"
                                               mode="ajax" minChars="0" autofill="true" selectFirst="true"
                                               autocompleteMethod="#{validationServiceBeanGui.autocomplete}"
                                               var="stylesheet"
                                               fetchValue="#{validationServiceBeanGui.validationServiceDto.stylesheetReportLocation}" layout="div">
                                <span>
                                    #{stylesheet}
                                </span>
                            </rich:autocomplete>
                        </s:decorate>

                        <s:decorate id="descriptionDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                            <ui:param name="id" value="descriptionId"/>
                            <ui:define name="label">#{messages['gazelle.evs.client.Description']}</ui:define>
                            <ui:decorate template="/layout/editor/_text_editor.xhtml">
                                <ui:param name="text" value="#{validationServiceBeanGui.validationServiceDto.description}"/>
                                <ui:param name="id" value="descriptionId"/>
                                <ui:param name="isFocus" value="true"/>
                            </ui:decorate>
                        </s:decorate>

                    </div>
                </s:div>

                <s:div id="specificDiv">
                    <div class="form-horizontal">
                        <s:decorate id="systemServiceDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml"
                                    rendered="#{validationServiceBeanGui.isSystemServiceTypeSelected()}">
                            <ui:define name="label">#{messages['net.ihe.gazelle.evs.PathToBinary']}</ui:define>
                            <ui:param name="id" value="path"/>
                            <h:inputText id="path" size="60" maxlength="255"
                                         required="true" styleClass="form-control"
                                         value="#{validationServiceBeanGui.validationServiceDto.binaryPath}">
                                <a4j:ajax event="blur" render="systemServiceDecoration" execute="@this"/>
                            </h:inputText>
                        </s:decorate>

                        <s:decorate id="webServiceDecoration" template="/layout/form/_form_field_horizontal_3-9.xhtml"
                                    rendered="#{validationServiceBeanGui.isWebServiceTypeSelected()}">
                            <ui:define name="label">#{messages['net.ihe.gazelle.evs.TargetEndpoint']}</ui:define>
                            <ui:param name="id" value="url"/>
                            <h:inputText id="url" size="60" maxlength="255"
                                         required="true" styleClass="form-control"
                                         value="#{validationServiceBeanGui.validationServiceDto.url}">
                                <a4j:ajax event="blur" render="webServiceDecoration" execute="@this"/>
                            </h:inputText>
                        </s:decorate>

                        <s:decorate id="zipTransportDecoration"
                                    template="/layout/form/_form_checkbox_horizontal_inline.xhtml"
                                    rendered="#{validationServiceBeanGui.isWebServiceTypeSelected()}">
                            <ui:param name="id" value="zipTransportCheckBox"/>
                            <h:selectBooleanCheckbox id="zipTransportCheckBox"
                                                     value="#{validationServiceBeanGui.validationServiceDto.zipTransport}"/>
                            <h:outputText value="#{messages['net.ihe.gazelle.evs.SupportCompression']}"/>
                        </s:decorate>
                    </div>
                </s:div>

                <s:div id="sharedDiv2">
                    <div class="form-horizontal">
                        <s:decorate id="availableDecoration"
                                    template="/layout/form/_form_checkbox_horizontal_inline.xhtml">
                            <ui:param name="id" value="availableCheckBox"/>
                            <h:selectBooleanCheckbox id="availableCheckBox"
                                                     value="#{validationServiceBeanGui.validationServiceDto.available}"/>
                            #{messages['gazelle.evs.client.isAvailable']}
                        </s:decorate>
                    </div>
                </s:div>

                <ui:define name="panel_footer">
                    <em class="pull-right">* #{messages['net.ihe.gazelle.evsclient.Required']}</em>
                </ui:define>
            </ui:decorate>

            <a4j:commandButton value="#{messages['net.ihe.gazelle.evs.SaveChanges']}"
                               action="#{validationServiceBeanGui.save()}" styleClass="gzl-btn-blue"
                               render="globalDiv" execute="@form"/>
            <h:outputLink title="#{messages['net.ihe.gazelle.evs.BackToList']}" value="validationServices.seam"
                          styleClass="gzl-btn">
                <h:outputText value="#{messages['net.ihe.gazelle.evs.BackToList']}"/>
            </h:outputLink>
        </h:form>
    </ui:define>
</ui:composition>
